﻿Public Class newsItem

    Private _fullItemXml As XmlNode

    Friend Sub New(ByVal id As Integer, ByVal headline As String, ByVal publishDate As Date, ByVal href As String)
        _id = id
        _headline = headline
        _publishDate = publishDate
        Me.fullItemHref = href
    End Sub

    Friend Sub New(ByVal newListItemXML As XmlNode)
        Me.New(Integer.Parse(newListItemXML.Item("id").InnerText), _
                                                       newListItemXML.Item("headline").InnerText, _
                                                       Date.Parse(newListItemXML.Item("publishDate").InnerText), _
                                                       newListItemXML.Attributes("href").InnerText)
    End Sub

    Private ReadOnly Property FullItemXml() As XmlElement
        Get
            Dim NewsItemXMLDoc As XmlDocument
            If _fullItemXml Is Nothing Then
                NewsItemXMLDoc = New XmlDocument
                Try
                    NewsItemXMLDoc.Load(fullItemHref)
                    _fullItemXml = NewsItemXMLDoc.Item("newsItem")
                    If _fullItemXml Is Nothing Then
                        Throw New NullReferenceException("parsing the 'newsItem' element failed.")
                    End If
                Catch ex As Exception
                    Throw New Exceptions.ApiNotAvailableException(ex)
                End Try
            End If
            Return _fullItemXml
        End Get
    End Property


    'Private Sub FetchFullItem()
    '    If Not FullItemLoaded Then
    '        'Load other fields
    '        'Dim NewsItemXMLDoc As New XmlDocument
    '        'Try
    '        '    NewsItemXMLDoc.Load(fullItemHref)
    '        'Catch ex As Exception
    '        '    Throw New Exceptions.ApiNotAvailableException(ex)
    '        'End Try
    '        Try
    '            Dim NewsItem As XmlNode = NewsItemXMLDoc.Item("newsItem")
    '            If NewsItem.Item("extract") IsNot Nothing Then _
    '                _extract = NewsItem.Item("extract").InnerText
    '            _text = NewsItem.Item("text").InnerText
    '            _format = NewsItem.Item("text").Attributes("format").InnerText
    '            If NewsItem.Item("byLine") IsNot Nothing Then _
    '                _byLine = NewsItem.Item("byLine").InnerText
    '            If NewsItem.Item("tweetText") IsNot Nothing Then _
    '                _tweetText = NewsItem.Item("tweetText").InnerText
    '            If NewsItem.Item("source") IsNot Nothing Then _
    '                _source = NewsItem.Item("source").InnerText
    '            If NewsItem.Item("clientQuote") IsNot Nothing Then _
    '                _clientQuote = NewsItem.Item("clientQuote").InnerText
    '            _createdDate = Date.Parse(NewsItem.Item("createdDate").InnerText)
    '            _lastModifiedDate = Date.Parse(NewsItem.Item("lastModifiedDate").InnerText)
    '            If NewsItem.Item("htmlTitle") IsNot Nothing Then _
    '                _htmlTitle = NewsItem.Item("htmlTitle").InnerText
    '            If NewsItem.Item("htmlMetaDescripiton") IsNot Nothing Then _
    '                _htmlMetaDescripiton = NewsItem.Item("htmlMetaDescripiton").InnerText
    '            If NewsItem.Item("htmlMetaKeywords") IsNot Nothing Then _
    '                _htmlMetaKeywords = NewsItem.Item("htmlMetaKeywords").InnerText
    '            If NewsItem.Item("htmlMetaLanguage") IsNot Nothing Then _
    '                _htmlMetaLanguage = NewsItem.Item("htmlMetaLanguage").InnerText
    '            If NewsItem.Item("tags") IsNot Nothing Then _
    '                _tags = NewsItem.Item("tags").InnerText
    '            If NewsItem.Item("priority") IsNot Nothing Then _
    '                Integer.TryParse(NewsItem.Item("priority").InnerText, _priority)
    '            If NewsItem.Item("categories") IsNot Nothing Then _
    '                categoriesHref = NewsItem.Item("categories").Attributes("href").InnerText
    '            If NewsItem.Item("photos") IsNot Nothing Then _
    '                photosHref = NewsItem.Item("photos").Attributes("href").InnerText
    '            If NewsItem.Item("comments") IsNot Nothing Then _
    '                commentsHref = NewsItem.Item("comments").Attributes("href").InnerText
    '            _encoding = NewsItem.Attributes("encoding").InnerText
    '            FullItemLoaded = True
    '        Catch ex As Exception
    '            Throw New Exceptions.ApiDecodeException(ex)
    '        End Try
    '    End If
    'End Sub

#Region "--- Fields ---"



    Private FullItemLoaded As Boolean = False

    Private _encoding As String
    Private fullItemHref As String
    Private _id As Integer
    Private _headline As String
    Private _extract As String
    Private _text As String
    Private _publishDate As Date
    Private _byLine As String
    Private _tweetText As String
    Private _source As String
    Private _clientQuote As String
    Private _createdDate As Date?
    Private _lastModifiedDate As Date?
    Private _htmlTitle As String
    Private _htmlMetaDescripiton As String
    Private _htmlMetaKeywords As String
    Private _htmlMetaLanguage As String
    Private _tags As String
    Private _state As enumeratedTypes.enumNewsItemState
    Private _format As String
    Private _priority As Integer?
    Private _categories As List(Of category)
    Private _photos As List(Of photo)
    Private _comments As List(Of comment)
    Private _categoriesHref As String
    Private _photosHref As String
    Private _commentsHref As String

#End Region

    Public ReadOnly Property encoding() As String
        Get
            'FetchFullItem()
            If String.IsNullOrEmpty(_encoding) Then
                If Me.FullItemXml.Attributes("encoding") IsNot Nothing Then
                    _encoding = Me.FullItemXml.Attributes("encoding").InnerText
                End If
            End If
            Return _encoding
        End Get
    End Property

    Public ReadOnly Property id() As Integer
        Get
            Return _id
        End Get
    End Property

    Public ReadOnly Property headline() As String
        Get
            Return _headline
        End Get
    End Property

    Public ReadOnly Property extract() As String
        Get
            If String.IsNullOrEmpty(_extract) Then
                If Me.FullItemXml.Item("extract") IsNot Nothing Then
                    _extract = Me.FullItemXml.Item("extract").InnerText
                End If
            End If
            Return _extract
        End Get
    End Property

    Public ReadOnly Property text() As String
        Get
            If String.IsNullOrEmpty(_text) Then
                If Me.FullItemXml.Item("text") IsNot Nothing Then
                    _text = Me.FullItemXml.Item("text").InnerText
                End If
            End If
            Return _text
        End Get
    End Property

    Public ReadOnly Property publishDate() As Date
        Get
            Return _publishDate
        End Get
    End Property

    Public ReadOnly Property byLine() As String
        Get
            If String.IsNullOrEmpty(_byLine) Then
                If Me.FullItemXml.Item("byLine") IsNot Nothing Then
                    _byLine = Me.FullItemXml.Item("byLine").InnerText
                End If
            End If
            Return _byLine
        End Get
    End Property

    Public ReadOnly Property tweetText() As String
        Get
            If String.IsNullOrEmpty(_tweetText) Then
                If Me.FullItemXml.Item("tweetText") IsNot Nothing Then
                    _tweetText = Me.FullItemXml.Item("tweetText").InnerText
                End If
            End If
            Return _tweetText
        End Get
    End Property

    Public ReadOnly Property source() As String
        Get
            If String.IsNullOrEmpty(_source) Then
                If Me.FullItemXml.Item("source") IsNot Nothing Then
                    _source = Me.FullItemXml.Item("source").InnerText
                End If
            End If
            Return _source
        End Get
    End Property

    Public ReadOnly Property clientQuote() As String
        Get
            If String.IsNullOrEmpty(_clientQuote) Then
                If Me.FullItemXml.Item("clientQuote") IsNot Nothing Then
                    _clientQuote = Me.FullItemXml.Item("clientQuote").InnerText
                End If
            End If
            Return _clientQuote
        End Get
    End Property

    Public ReadOnly Property createdDate() As Date
        Get
            If Not _createdDate.HasValue Then
                If Me.FullItemXml.Item("createdDate") IsNot Nothing Then
                    _createdDate = Date.Parse(Me.FullItemXml.Item("createdDate").InnerText)
                End If
            End If
            Return _createdDate.Value
        End Get
    End Property

    Public ReadOnly Property lastModifiedDate() As Date
        Get
            If Not _lastModifiedDate.HasValue Then
                If Me.FullItemXml.Item("lastModifiedDate") IsNot Nothing Then
                    _lastModifiedDate = Date.Parse(Me.FullItemXml.Item("lastModifiedDate").InnerText)
                End If
            End If
            Return _lastModifiedDate.Value
        End Get
    End Property

    Public ReadOnly Property htmlTitle() As String
        Get
            If String.IsNullOrEmpty(_htmlTitle) Then
                If Me.FullItemXml.Item("htmlTitle") IsNot Nothing Then
                    _htmlTitle = Me.FullItemXml.Item("htmlTitle").InnerText
                End If
            End If
            Return _htmlTitle
        End Get
    End Property

    Public ReadOnly Property htmlMetaDescription() As String
        Get
            If String.IsNullOrEmpty(_htmlMetaDescripiton) Then
                If Me.FullItemXml.Item("htmlMetaDescripiton") IsNot Nothing Then
                    _htmlMetaDescripiton = Me.FullItemXml.Item("htmlMetaDescripiton").InnerText
                End If
            End If
            Return _htmlMetaDescripiton
        End Get
    End Property

    Public ReadOnly Property htmlMetaKeywords() As String
        Get
            If String.IsNullOrEmpty(_htmlMetaKeywords) Then
                If Me.FullItemXml.Item("htmlMetaKeywords") IsNot Nothing Then
                    _htmlMetaKeywords = Me.FullItemXml.Item("htmlMetaKeywords").InnerText
                End If
            End If
            Return _htmlMetaKeywords
        End Get
    End Property

    Public ReadOnly Property htmlMetaLanguage() As String
        Get
            If String.IsNullOrEmpty(_htmlMetaLanguage) Then
                If Me.FullItemXml.Item("htmlMetaLanguage") IsNot Nothing Then
                    _htmlMetaLanguage = Me.FullItemXml.Item("htmlMetaLanguage").InnerText
                End If
            End If
            Return _htmlMetaLanguage
        End Get
    End Property

    Public ReadOnly Property tags() As String
        Get
            If String.IsNullOrEmpty(_tags) Then
                If Me.FullItemXml.Item("tags") IsNot Nothing Then
                    _tags = Me.FullItemXml.Item("tags").InnerText
                End If
            End If
            Return _tags
        End Get
    End Property

    Public ReadOnly Property priority() As Integer
        Get
            If Not _priority.HasValue Then
                If Me.FullItemXml.Item("priority") IsNot Nothing Then
                    _priority = Integer.Parse(Me.FullItemXml.Item("priority").InnerText)
                Else
                    _priority = 0
                End If
            End If
            Return _priority.Value
        End Get
    End Property

    Public ReadOnly Property state() As enumeratedTypes.enumNewsItemState
        Get
            If _state = enumeratedTypes.enumNewsItemState.None Then
                If Me.FullItemXml.Item("state") IsNot Nothing Then
                    _state = Me.FullItemXml.Item("state").InnerText
                End If
            End If
            Return _state
        End Get
    End Property

    Public ReadOnly Property format() As String
        Get
            If String.IsNullOrEmpty(_format) Then
                If Me.FullItemXml.Item("text").Attributes("format") IsNot Nothing Then
                    _format = Me.FullItemXml.Item("text").Attributes("format").InnerText
                End If
            End If
            Return _format
        End Get
    End Property

    Public ReadOnly Property CategoriesHref() As String
        Get
            If String.IsNullOrEmpty(_categoriesHref) Then
                Try
                    _categoriesHref = Me.FullItemXml.Item("categories").Attributes("href").InnerText
                Catch ex As NullReferenceException
                    Throw New Exception("Failed to parse 'categories/@href' attribute", ex)
                End Try
            End If
            Return _categoriesHref
        End Get
    End Property

    Public ReadOnly Property PhotosHref() As String
        Get
            If String.IsNullOrEmpty(_photosHref) Then
                Try
                    _photosHref = Me.FullItemXml.Item("photos").Attributes("href").InnerText
                Catch ex As NullReferenceException
                    Throw New Exception("Failed to parse 'photos/@href' attribute", ex)
                End Try
            End If
            Return _photosHref
        End Get
    End Property

    Public ReadOnly Property CommentsHref() As String
        Get
            If String.IsNullOrEmpty(_commentsHref) Then
                Try
                    _commentsHref = Me.FullItemXml.Item("comments").Attributes("href").InnerText
                Catch ex As NullReferenceException
                    Throw New Exception("Failed to parse 'comments/@href' attribute", ex)
                End Try
            End If
            Return _commentsHref
        End Get
    End Property

    Public ReadOnly Property categories() As IEnumerable(Of category)
        Get

            If _categories Is Nothing Then
                _categories = New List(Of category)
                If Not String.IsNullOrEmpty(Me.CategoriesHref) Then
                    'Load categories from service
                    Dim CategoriesXMLDoc As New XmlDocument
                    Try
                        CategoriesXMLDoc.Load(Me.CategoriesHref)
                    Catch ex As Exception
                        Throw New Exceptions.ApiNotAvailableException(ex)
                    End Try
                    Try
                        Dim CategoryEnumerator As IEnumerator = CategoriesXMLDoc.Item("categories").ChildNodes.GetEnumerator
                        While CategoryEnumerator.MoveNext
                            Dim CategoryXML As XmlNode = DirectCast(CategoryEnumerator.Current, XmlNode)
                            _categories.Add(New category(CategoryXML))
                        End While
                    Catch ex As Exception
                        Throw New Exceptions.ApiDecodeException(ex)
                    End Try
                End If
            End If
            Return _categories
        End Get
    End Property

    Public ReadOnly Property photos() As IEnumerable(Of photo)
        Get
            If _photos Is Nothing Then
                _photos = New List(Of photo)
                If Not String.IsNullOrEmpty(Me.PhotosHref) Then
                    'Load photos from service
                    Dim PhotosXMLDoc As New XmlDocument
                    Try
                        PhotosXMLDoc.Load(Me.PhotosHref)
                    Catch ex As Exception
                        Throw New Exceptions.ApiNotAvailableException(ex)
                    End Try
                    Try
                        For Each PhotoNode As XmlNode In PhotosXMLDoc.Item("photos").ChildNodes

                            _photos.Add(New photo(PhotoNode))
                        Next
                    Catch ex As Exception
                        Throw New Exceptions.ApiDecodeException(ex)
                    End Try
                End If
            End If
            Return _photos
        End Get
    End Property

    Public ReadOnly Property comments() As IEnumerable(Of comment)
        Get
            If _comments Is Nothing Then
                _comments = New List(Of comment)
                If Not String.IsNullOrEmpty(CommentsHref) Then
                    'Load categories from service
                    Dim CommentsXMLDoc As New XmlDocument
                    Try
                        CommentsXMLDoc.Load(CommentsHref)
                    Catch ex As Exception
                        Throw New Exceptions.ApiNotAvailableException(ex)
                    End Try
                    Try
                        Dim CommentEnumerator As IEnumerator = CommentsXMLDoc.Item("comments").ChildNodes.GetEnumerator
                        While CommentEnumerator.MoveNext
                            Dim CommentNode As XmlNode = DirectCast(CommentEnumerator.Current, XmlNode)
                            _comments.Add(New comment(CommentNode))
                        End While
                    Catch ex As Exception
                        Throw New Exceptions.ApiDecodeException(ex)
                    End Try
                End If
            End If
            Return _comments
        End Get
    End Property

End Class
