﻿
Public Class photo
    Friend Sub New(ByVal photoXML As XmlNode)
        MyBase.New()
        _id = Integer.Parse(photoXML.Item("id").InnerText)
        _htmlAlt = If(photoXML.Item("htmlAlt") Is Nothing, Nothing, photoXML.Item("htmlAlt").InnerText)
        _orientationValue = photoXML.Item("orientation").InnerText
        _photoXML = photoXML
    End Sub

    Private _id As Integer
    Private _htmlAlt As String
    Private _orientation As enumeratedTypes.enumPhotoOrientation
    Private _orientationValue As String
    Private _photoXML As XmlNode
    Private _instances As List(Of Instance)

    Private ReadOnly Property photoXML() As XmlNode
        Get
            Return _photoXML
        End Get
    End Property

    Public ReadOnly Property id() As Integer
        Get
            Return _id
        End Get
    End Property

    Public ReadOnly Property htmlAlt() As String
        Get
            Return _htmlAlt
        End Get
    End Property

    Public ReadOnly Property orientation() As enumeratedTypes.enumPhotoOrientation
        Get
            Select Case _orientationValue
                Case "Landscape"
                    _orientation = enumeratedTypes.enumPhotoOrientation.Landscape
                Case "Portrait"
                    _orientation = enumeratedTypes.enumPhotoOrientation.Portrait
                Case Else
                    Throw New Exception("A matching Photo Orientation was not found!")
            End Select
            Return _orientation
        End Get
    End Property

    Public ReadOnly Property Instances() As IEnumerable(Of Instance)
        Get
            If _instances Is Nothing Then

                If Me.photoXML.Item("instances") IsNot Nothing Then
                    _instances = New List(Of Instance)
                    For Each PhotoInstanceNode As XmlNode In Me.photoXML.Item("instances").ChildNodes
                        _instances.Add(New Instance(PhotoInstanceNode))
                    Next
                End If

            End If

            Return _instances
        End Get
    End Property

    Public Class Instance

        Friend Sub New(ByVal width As Integer, ByVal height As Integer, ByVal type As String, ByVal url As String)
            _width = width
            _height = height
            _typeValue = type
            _url = url
        End Sub

        Friend Sub New(ByVal instaceXML As XmlNode)
            Me.New(Integer.Parse(instaceXML.Item("width").InnerText), _
                                                    Integer.Parse(instaceXML.Item("height").InnerText), _
                                                    instaceXML.Item("type").InnerText, _
                                                    instaceXML.Item("url").InnerText)
        End Sub

        Private _width As Integer
        Private _height As Integer
        Private _type As enumeratedTypes.enumPhotoInstanceType
        Private _typeValue As String
        Private _url As String

        Public ReadOnly Property width() As Integer
            Get
                Return _width
            End Get
        End Property

        Public ReadOnly Property height() As Integer
            Get
                Return _height
            End Get
        End Property

        Public ReadOnly Property type() As enumeratedTypes.enumPhotoInstanceType
            Get
                Select Case _typeValue
                    Case "Thumbnail"
                        _type = enumeratedTypes.enumPhotoInstanceType.Thumbnail
                    Case "Large"
                        _type = enumeratedTypes.enumPhotoInstanceType.Large
                    Case "HighRes"
                        _type = enumeratedTypes.enumPhotoInstanceType.HighRes
                    Case "Custom"
                        _type = enumeratedTypes.enumPhotoInstanceType.Custom
                    Case "Small"
                        _type = enumeratedTypes.enumPhotoInstanceType.Small
                    Case "Medium"
                        _type = enumeratedTypes.enumPhotoInstanceType.Medium
                    Case Else
                        Throw New Exception("A matching Photo Instance Type was not found")
                End Select

                Return _type
            End Get
        End Property

        Public ReadOnly Property url() As String
            Get
                Return _url
            End Get
        End Property

    End Class

End Class
